AC_DEFUN(AC_CHECK_EMACS, [
  dnl Apparently, if you run a shell window in Emacs, it sets the EMACS
  dnl environment variable to 't'.  Lets undo the damage.
  test "$EMACS" = t && EMACS=
  AC_ARG_WITH(emacs,
   [  --with-emacs=EMACS      compile with EMACS [[EMACS=emacs]]],
   [if test "$withval" = yes -o -z "$withval"; then
      AC_CHECK_PROG(EMACS, emacs, emacs, emacs)
    else
      AC_CHECK_PROG(EMACS, $withval, $withval, emacs)
    fi],
    AC_CHECK_PROG(EMACS, emacs, emacs, emacs))
  AC_SUBST(EMACS)])

AC_DEFUN(AC_EMACS_LISP, [
  elisp="$2"
  if test -z "$3"; then
    AC_MSG_CHECKING(for $1)
  fi
  AC_CACHE_VAL(EMACS_cv_SYS_$1,[
    OUTPUT=./conftest-$$
    echo ${EMACS}' -batch -eval '\''(let ((x '${elisp}')) (write-region (if (stringp x) (princ x) (prin1-to-string x)) nil "'${OUTPUT}'" nil 5))'\' >& AC_FD_CC 2>&1
    eval ${EMACS}' -batch -eval '\''(let ((x '${elisp}')) (write-region (if (stringp x) (princ x) (prin1-to-string x)) nil "'${OUTPUT}'" nil 5))'\' >& AC_FD_CC 2>&1
    retval=`cat ${OUTPUT}`
    echo "=> ${retval}" >& AC_FD_CC 2>&1
    rm -f ${OUTPUT}
    EMACS_cv_SYS_$1=$retval
  ])
  $1=${EMACS_cv_SYS_$1}
  if test -z "$3"; then
    AC_MSG_RESULT($$1)
  fi])

AC_DEFUN(AC_PATH_LISPDIR, [
  AC_MSG_CHECKING([for directory where lisp files should go])
  AC_ARG_WITH(lispdir,
   [  --with-lispdir=LISPDIR  directory where Lisp files should go
                          [[LISPDIR=<data-directory>/../site-lisp/sj3-egg]]],
   [if test "$withval" = yes -o -z "$withval"; then
      AC_EMACS_LISP(lispdir,
        (expand-file-name \"../site-lisp/sj3-egg\" data-directory),
        "noecho")
    else
      lispdir=${withval}
    fi],
    AC_EMACS_LISP(lispdir,
      (expand-file-name \"../site-lisp/sj3-egg\" data-directory),
      "noecho"))
  AC_MSG_RESULT([
         $lispdir])
  AC_SUBST(lispdir)])
